#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/page.h>
#include <arpa/inet.h>

#include "axi_ctrl.h"

void wait_for_cdma_idle(struct axi_cdma_ctrl* ptr)
{
	while((ptr->cdmasr & 0x00000002) == 0x00000000) ;
}

int main(int argc,char **argv)
{
	struct axi_ctrl_env env;
	unsigned int addr;
	if(argc < 5){
		printf("usage: ./dma_test sa da len addr\n");
		printf("ex. ./dma_test 0x40000000 0x20000000 1024 0x60000000\n");
		exit(0);
	}
	open_ctrl_map(&env);

	wait_for_cdma_idle(env.cdma);

	addr = strtol(argv[4], NULL, 0);
	printf("%08x\n", env.pcie->axibar2pciebar_1U);
	printf("%08x\n", env.pcie->axibar2pciebar_1L);
	env.pcie->axibar2pciebar_1U = 0x00000000;
        env.pcie->axibar2pciebar_1L = addr;
	printf("%08x\n", env.pcie->axibar2pciebar_1U);
	printf("%08x\n", env.pcie->axibar2pciebar_1L);

	env.cdma->sa  = strtol(argv[1], NULL, 0); // ex. 0x40000000
	env.cdma->da  = strtol(argv[2], NULL, 0); // ex. 0x20000000
	env.cdma->btt = strtol(argv[3], NULL, 0);

	wait_for_cdma_idle(env.cdma);

	close_ctrl_map(&env);
	return 0;
}

