#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/page.h>
#include <arpa/inet.h>

#include "axi_ctrl.h"
#include "pcie_config_read.h"

void hexdump(unsigned char *ptr, int len)
{
	int i;
	for(i = 0; i < len; i++){
		if(i % 16 == 0) printf(" %08x:", i);
		printf(" %02x", *(ptr+i));
		if(i % 16 == 15) printf("\n");
	}
	if(i % 16 == 0) printf("\n");
}

int main(int argc,char **argv)
{
	struct axi_ctrl_env env;
	struct pcie_config_space *info;
	open_ctrl_map(&env);
	hexdump(env.pcie->pcie_configuration_header, 0x40);

	info = (struct pcie_config_space*)(env.pcie->pcie_configuration_header);

	printf("Device ID: %04x\n", info->device_id);
	printf("Vendor ID: %04x\n", info->vendor_id);
	printf("interrupt LINE: %02x\n", info->interrupt_line);
	printf("interrupt PIN: %02x\n", info->interrupt_pin);
	close_ctrl_map(&env);
	return 0;
}
