#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/page.h>

int main(int argc,char **argv)
{
	char *mmaped;
	int fd;
	unsigned int base, len;
	int i;

	if(argc < 3){ printf("usage: ./test-seq base len\n"); exit(0); }
	base = (unsigned int)strtol(argv[1], NULL, 0);
	len =  (unsigned int)strtol(argv[2], NULL, 0);

	fd = open("/dev/mem", O_RDWR);
	if(fd < 0){
		fprintf(stderr,"cannot open %s\n", "/dev/mem");
		return 1;
	}

	printf("mmap : start %08X  len:%08X\n", base, len);
	mmaped = mmap(0, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, base);

	if(mmaped == MAP_FAILED){
		fprintf(stderr,"cannot mmap\n");
		return 1;
	}

	printf("read: start %08X  len:%08X\n", base, len);
	for(i = 0; i < len/4; i++){
		if(i % 4 == 0) printf("%08x:", i);
		printf(" %08x", *(((unsigned int*)mmaped) + i));
		if(i % 4 == 3) printf("\n");
	}
	if(i % 4 == 0) printf("\n");

	munmap(mmaped, len);
	close(fd);
	return 0;
}

